// kc.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "kc.h"
#include "savepix.h"
#include <Dbgapi.h>
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>
#include <gx.h>

#define MAX_LOADSTRING 100

#define MENU_TIMER 1
#define EXIT_TIMER 1

// Global Variables:
HINSTANCE			hInst;					// The current instance
HWND				hwndCB;					// The command bar handle

HWND				g_hwndTB;
HWND				g_hwndDrawingArea;
HBITMAP				g_hBitmap;
HDC					g_onscreenDC;
HDC					g_offscreenDC;
int					g_width, g_height;
int					g_lastx = -1;
int					g_lasty = -1;
int					g_hMenuTimer = 0;
int					g_hExitTimer = 0;


COLORREF			g_strokecolor;
int                 g_strokewidth;
HPEN g_hpen;

static SHACTIVATEINFO s_sai;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	AboutDlgMsgHandler (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	ColorDlgMsgHandler (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	ClearDlgMsgHandler (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	WidthDlgMsgHandler (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	ExitDlgMsgHandler (HWND, UINT, WPARAM, LPARAM);
HWND				CreateRpCommandBar(HWND);
HWND				CreateKCToolbar(HWND);
void				SaveImage();
DWORD				GetCounterValue ();


void CALLBACK MenuTimerCallback(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime );
void CALLBACK ExitTimerCallback(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime );


int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_KC);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    It is important to call this function so that the application 
//    will get 'well formed' small icons associated with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_KC));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}


void KillMenuTimer ()
{
	if (g_hMenuTimer) KillTimer (NULL, g_hMenuTimer);
}

void SetMenuTimer ()
{
	KillMenuTimer ();
	g_hMenuTimer = SetTimer (NULL, MENU_TIMER, 2500, (TIMERPROC)MenuTimerCallback);
	//DEBUGMSG (1, (_T("Set menu timer (%d)\n"), g_hMenuTimer));
}


void CALLBACK MenuTimerCallback(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime )
{
	if (g_hwndTB)
		ShowWindow (g_hwndTB, SW_SHOW);

}


void KillExitTimer ()
{
	if (g_hExitTimer) KillTimer (NULL, g_hExitTimer);
}

void SetExitTimer ()
{
	KillExitTimer ();
	g_hExitTimer = SetTimer (NULL, EXIT_TIMER, 2500, (TIMERPROC)ExitTimerCallback);
	//DEBUGMSG (1, (_T("Set exit timer (%d)\n"), g_hExitTimer));
}


void CALLBACK ExitTimerCallback(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime )
{
	KillExitTimer ();
	DialogBox(hInst, (LPCTSTR)IDD_EXIT, NULL, (DLGPROC)ExitDlgMsgHandler);
}


void SetFullScreen (HWND hWnd)
{
	BOOL bRetVal = SHFullScreen(hWnd, SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON | SHFS_HIDESTARTICON);
	bRetVal = MoveWindow( hWnd, 
                0, 
                0, 
                g_width, 
                g_height, 
                TRUE);

}


void ClearImage (COLORREF cr = 0xFF000000)
{
	RECT newrc;
	
	HBRUSH br = (cr == 0xFF000000)
		? CreateSolidBrush (RGB (255, 255, 255))
		: CreateSolidBrush (cr);

	newrc.top = 0;
	newrc.left = 0;
	newrc.bottom = g_height;
	newrc.right = g_width;
	FillRect (g_offscreenDC, &newrc, br);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd = NULL;
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name

	hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_KC, szWindowClass, MAX_LOADSTRING);
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);

	//If it is already running, then focus on the window
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) 
	{
		SetForegroundWindow ((HWND) (((DWORD)hWnd) | 0x01));    
		return 0;
	} 

	MyRegisterClass(hInstance, szWindowClass);
	
	RECT	rect;
	GetClientRect(hWnd, &rect);

	
	/*
	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	if (!hWnd)
	{	
		return FALSE;
	}
	//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	// is created is not taken into account). So we resize the window after creating it
	// if a menubar is present
	{
		RECT rc;
		GetWindowRect(hWnd, &rc);
		rc.bottom -= MENU_HEIGHT;
		if (hwndCB)
			MoveWindow(hWnd, rc.left, rc.top, rc.right, rc.bottom, FALSE);
	}
*/

#define MENU_HEIGHT 26
	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
           CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
           CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	if (!hWnd)
	{    
	   return FALSE;
	}
	g_hwndDrawingArea = hWnd;

	RECT rc;
	GetWindowRect(hWnd, &rc);
	g_width = rc.right - rc.left;
	g_height = rc.bottom - rc.top + MENU_HEIGHT;

	SetFullScreen (hWnd);

	HDC dc = GetDC (hWnd);
	g_onscreenDC = dc;
	g_offscreenDC = CreateCompatibleDC (dc);
	g_hBitmap = CreateCompatibleBitmap(dc, g_width, g_height);
	SelectObject (g_offscreenDC, g_hBitmap);

	ClearImage();

	g_strokecolor = RGB (0, 0, 0);
	g_strokewidth = 3;

	g_hpen = CreatePen (PS_SOLID, g_strokewidth, g_strokecolor);
	SelectObject (g_onscreenDC, g_hpen);
	SelectObject (g_offscreenDC, g_hpen);

	if (g_hwndTB)
		MoveWindow(hWnd, rc.left, rc.top - MENU_HEIGHT, rc.right, rc.bottom, FALSE);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	// "disable" hardware buttons -- now all hw button presses will be
	// passed to the app instead of to the shell.
	GXOpenInput ();

	return TRUE;
}

void
drawStroke (HWND hWnd, int x, int y)
{
	static POINT pp[2];

	if (g_lastx == -1) {
		return;
	}

	pp[0].x = g_lastx;
	pp[0].y = g_lasty;
	pp[1].x = x;
	pp[1].y = y;

//	DEBUGMSG (1, (_T("%d, %d\n"), x, y));

	// draw in the offscreen buffer
	Polyline(g_offscreenDC, pp, 2); 

	// draw in the onscreen buffer
	Polyline (g_onscreenDC, pp, 2);

	g_lastx = x;
	g_lasty = y;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	int wmId, wmEvent;
	PAINTSTRUCT ps;

	int fwKeys;
	int xPos;
	int yPos;

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{	
				case IDM_ABOUT:
					KillMenuTimer ();
					DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)AboutDlgMsgHandler);

					if (g_hwndTB) ShowWindow (g_hwndTB, SW_SHOW);
				    SetFullScreen (hWnd);
					break;

				case IDM_EXIT:
					KillMenuTimer ();
					SetExitTimer ();
//					CommandBar_Destroy (g_hwndTB);
//					PostQuitMessage(0);
					break;

				case IDM_SAVE:
					SaveImage ();
					break;

				case IDM_HIDE_MENU:
					if (g_hwndTB) ShowWindow (g_hwndTB, SW_HIDE);
					SetFullScreen (hWnd);
					SetMenuTimer ();
					break;

				case IDM_COLOR:
					KillMenuTimer ();
					DialogBox (hInst, (LPCTSTR)IDD_COLORDIALOG, hWnd, (DLGPROC)ColorDlgMsgHandler);
					if (g_hwndTB) ShowWindow (g_hwndTB, SW_HIDE);
					SetFullScreen (hWnd);
					SetMenuTimer ();
					break;

				case IDM_WIDTHS:
					KillMenuTimer ();
					DialogBox (hInst, (LPCTSTR)IDD_WIDTHDIALOG, hWnd, (DLGPROC)WidthDlgMsgHandler);
					if (g_hwndTB) ShowWindow (g_hwndTB, SW_HIDE);
					SetFullScreen (hWnd);
					SetMenuTimer ();
					
					break;

				case IDM_CLEAR:
					KillMenuTimer ();
					DialogBox (hInst, (LPCTSTR)IDD_COLORDIALOG, hWnd, (DLGPROC)ClearDlgMsgHandler);
					if (g_hwndTB) ShowWindow (g_hwndTB, SW_SHOW);
				    SetFullScreen (hWnd);
					break;

				case IDOK:
					SendMessage(hWnd, WM_ACTIVATE, MAKEWPARAM(WA_INACTIVE, 0), (LPARAM)hWnd);
					SendMessage (hWnd, WM_CLOSE, 0, 0);
					break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_CREATE:
			//hwndCB = CreateRpCommandBar(hWnd);
			g_hwndTB = CreateKCToolbar (hWnd);
			break;
		case WM_LBUTTONUP:
			g_lastx = -1;
			g_lasty = -1;
			SetMenuTimer ();
			break;

		case WM_LBUTTONDOWN:
			g_lastx = LOWORD(lParam);
			g_lasty = HIWORD(lParam);
			KillMenuTimer ();
			KillExitTimer ();
			if (g_hwndTB) ShowWindow (g_hwndTB, SW_HIDE);
			SetFullScreen (hWnd);
			break;

		case WM_MOUSEMOVE:
			fwKeys = wParam;
			xPos = LOWORD(lParam);
			yPos = HIWORD(lParam);
			drawStroke (hWnd, xPos, yPos);
			break;

		case WM_PAINT:
			RECT rt;
			if (GetUpdateRect (hWnd, &rt, FALSE)) {
				hdc = BeginPaint(hWnd, &ps);
				BitBlt (hdc, rt.left, rt.top, rt.right-rt.left, rt.bottom-rt.top, g_offscreenDC, rt.left, rt.top, SRCCOPY);
				EndPaint(hWnd, &ps);
			}
			else {
				// do nothing
			}

			/*
			GetClientRect(hWnd, &rt);
			LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);
			DrawText(hdc, szHello, _tcslen(szHello), &rt, 
				DT_SINGLELINE | DT_VCENTER | DT_CENTER);
				*/
			
			GetWindowRect(hWnd, &rt);

			break; 
		case WM_DESTROY:
			CommandBar_Destroy (g_hwndTB);
			// restore button presses to their normal behavior
			GXCloseInput ();
			PostQuitMessage(0);
			break;
		case WM_SETTINGCHANGE:
			SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
     		break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MENU;
	mbi.hInstRes   = hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;
	

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	return mbi.hwndMB;
}


/*
OK -- to build a button-based toolbar, you create a "Menubar",
then use the toolbar editor to edit a bitmap (the toolbar editor
is really a glorified image editor; the resulting resource is really
just a bitmap.  Then in the menubar editor, you select the ID of
your toolbar resource in the menubar's properties.  For each button
that you want to have an image, you set its properties to an offset
into the image.
*/
HWND CreateKCToolbar(HWND hwnd)
{
	BOOL fSuccess;
	SHMENUBARINFO mbi;	

    memset(&mbi, 0, sizeof(SHMENUBARINFO));
    mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hInstRes = hInst;
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDR_MENUBAR1;
	mbi.nBmpId = IDB_TOOLBAR1;
	mbi.cBmpImages = 6;
	mbi.dwFlags = SHCMBF_HIDESIPBUTTON;
	if (!(fSuccess = SHCreateMenuBar(&mbi)))
		return NULL;

	return mbi.hwndMB;
}



// Mesage handler for the About box.
LRESULT CALLBACK AboutDlgMsgHandler(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
		case WM_INITDIALOG:
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_FULLSCREENNOMENUBAR | SHIDIF_SIPDOWN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			SetFullScreen (hDlg);
			return TRUE; 

		case WM_LBUTTONDOWN:
			EndDialog (hDlg, LOWORD (wParam));
			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

COLORREF GetColor (int x, int y)
{
	/*
	0 - 27
28 - 54
55 - 81
82 - 108
109 - 135
136 - 162
163 - 189
190 - 216
*/
	x -= 12;
	y -= 35;

	//DEBUGMSG (1, (_T("clicked on (%d, %d)\n"), x, y));

	if (y >= 0 && y < 28) {
		if (x >= 0 && x < 28) {
			return RGB (64, 0, 0);
		}
		else if (x >= 28 && x < 55) {
			return RGB (128, 0, 0);
		}
		else if (x >= 55 && x < 82) {
			return RGB (160, 0, 0);
		}
		else if (x >= 82 && x < 109) {
			return RGB (192, 0, 0);
		}
		else if (x >= 109 && x < 136) {
			return RGB (255, 0, 0);
		}
		else if (x >= 136 && x < 163) {
			return RGB (255, 32, 32);
		}
		else if (x >= 163 && x < 190) {
			return RGB (255, 64, 64);
		}
		else if (x >= 190 && x < 217) {
			return RGB (255, 128, 128);
		}

	}
	else if (y >= 28 && y < 55) {
		if (x >= 0 && x < 28) {
			return RGB (64, 24, 0);
		}
		else if (x >= 28 && x < 55) {
			return RGB (121, 46, 0);
		}
		else if (x >= 55 && x < 82) {
			return RGB (166, 63, 0);
		}
		else if (x >= 82 && x < 109) {
			return RGB (210, 79, 0);
		}
		else if (x >= 109 && x < 136) {
			return RGB (255, 96, 0);
		}
		else if (x >= 136 && x < 163) {
			return RGB (255, 121, 40);
		}
		else if (x >= 163 && x < 190) {
			return RGB (255, 141, 72);
		}
		else if (x >= 190 && x < 217) {
			return RGB (255, 169, 117);
		}
	}
	else if (y >= 55 && y < 82) {
		if (x >= 0 && x < 28) {
			return RGB (64, 64, 0);
		}
		else if (x >= 28 && x < 55) {
			return RGB (128, 128, 0);
		}
		else if (x >= 55 && x < 82) {
			return RGB (160, 160, 0);
		}
		else if (x >= 82 && x < 109) {
			return RGB (192, 192, 0);
		}
		else if (x >= 109 && x < 136) {
			return RGB (255, 255, 0);
		}
		else if (x >= 136 && x < 163) {
			return RGB (255, 255, 32);
		}
		else if (x >= 163 && x < 190) {
			return RGB (255, 255, 64);
		}
		else if (x >= 190 && x < 217) {
			return RGB (255, 255, 128);
		}
	}
	else if (y >= 82 && y < 109) {
		if (x >= 0 && x < 28) {
			return RGB (0, 64, 0);
		}
		else if (x >= 28 && x < 55) {
			return RGB (0, 96, 0);
		}
		else if (x >= 55 && x < 82) {
			return RGB (0, 128, 0);
		}
		else if (x >= 82 && x < 109) {
			return RGB (0, 192, 0);
		}
		else if (x >= 109 && x < 136) {
			return RGB (0, 255, 0);
		}
		else if (x >= 136 && x < 163) {
			return RGB (32, 255, 32);
		}
		else if (x >= 163 && x < 190) {
			return RGB (64, 255, 64);
		}
		else if (x >= 190 && x < 217) {
			return RGB (128, 255, 128);
		}
	}
	else if (y >= 109 && y < 136) {
		if (x >= 0 && x < 28) {
			return RGB (0, 0, 64);
		}
		else if (x >= 28 && x < 55) {
			return RGB (0, 0, 96);
		}
		else if (x >= 55 && x < 82) {
			return RGB (0, 0, 128);
		}
		else if (x >= 82 && x < 109) {
			return RGB (0, 0, 192);
		}
		else if (x >= 109 && x < 136) {
			return RGB (0, 0, 255);
		}
		else if (x >= 136 && x < 163) {
			return RGB (32, 32, 255);
		}
		else if (x >= 163 && x < 190) {
			return RGB (64, 64, 255);
		}
		else if (x >= 190 && x < 217) {
			return RGB (128, 128, 255);
		}
	}
	else if (y >= 136 && y < 163) {
		if (x >= 0 && x < 28) {
			return RGB (32, 0, 64);
		}
		else if (x >= 28 && x < 55) {
			return RGB (61, 0, 121);
		}
		else if (x >= 55 && x < 82) {
			return RGB (83, 0, 166);
		}
		else if (x >= 82 && x < 109) {
			return RGB (105, 0, 210);
		}
		else if (x >= 109 && x < 136) {
			return RGB (128, 0, 255);
		}
		else if (x >= 136 && x < 163) {
			return RGB (128, 32, 255);
		}
		else if (x >= 163 && x < 190) {
			return RGB (128, 64, 255);
		}
		else if (x >= 190 && x < 217) {
			return RGB (128, 128, 255);
		}
	}
	else if (y >= 163 && y < 190) {
		if (x >= 0 && x < 28) {
			return RGB (64, 0, 64);
		}
		else if (x >= 28 && x < 55) {
			return RGB (96, 0, 96);
		}
		else if (x >= 55 && x < 82) {
			return RGB (160, 0, 160);
		}
		else if (x >= 82 && x < 109) {
			return RGB (192, 0, 192);
		}
		else if (x >= 109 && x < 136) {
			return RGB (255, 0, 255);
		}
		else if (x >= 136 && x < 163) {
			return RGB (255, 32, 255);
		}
		else if (x >= 163 && x < 190) {
			return RGB (255, 64, 255);
		}
		else if (x >= 190 && x < 217) {
			return RGB (255, 128, 255);
		}
	}
	else if (y >= 190 && y < 217) {
		if (x >= 0 && x < 28) {
			return RGB (0, 0, 0);
		}
		else if (x >= 28 && x < 55) {
			return RGB (32, 32, 32);
		}
		else if (x >= 55 && x < 82) {
			return RGB (64, 64, 64);
		}
		else if (x >= 82 && x < 109) {
			return RGB (96, 96, 96);
		}
		else if (x >= 109 && x < 136) {
			return RGB (128, 128, 128);
		}
		else if (x >= 136 && x < 163) {
			return RGB (160, 160, 160);
		}
		else if (x >= 163 && x < 190) {
			return RGB (192, 192, 192);
		}
		else if (x >= 190 && x < 217) {
			return RGB (255, 255, 255);
		}
	}

	return RGB (0, 0, 0);
}

// Mesage handler for the Color chooser
LRESULT CALLBACK ColorDlgMsgHandler(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	int xPos, yPos;

	switch (message)
	{
		case WM_INITDIALOG:
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_FULLSCREENNOMENUBAR | SHIDIF_SIPDOWN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			SetFullScreen (hDlg);
			return TRUE; 

		case WM_LBUTTONDOWN:
			xPos = LOWORD(lParam);
			yPos = HIWORD(lParam);
			g_strokecolor = GetColor (xPos, yPos);

			g_hpen = CreatePen (PS_SOLID, g_strokewidth, g_strokecolor);
			SelectObject (g_onscreenDC, g_hpen);
			SelectObject (g_offscreenDC, g_hpen);

			EndDialog(hDlg, LOWORD(wParam));
			break;

		case WM_COMMAND:
			EndDialog(hDlg, LOWORD(wParam));
			/*
			if (LOWORD(wParam) == IDOK) {
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			*/
			break;
	}
    return FALSE;
}


// Mesage handler for the clear color chooser.
LRESULT CALLBACK ClearDlgMsgHandler(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	int xPos, yPos;
	COLORREF cr_clear;

	switch (message)
	{
		case WM_INITDIALOG:
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_FULLSCREENNOMENUBAR | SHIDIF_SIPDOWN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			SetFullScreen (hDlg);
			return TRUE; 

		case WM_LBUTTONDOWN:
			xPos = LOWORD(lParam);
			yPos = HIWORD(lParam);
			cr_clear = GetColor (xPos, yPos);

			ClearImage (cr_clear);
			EndDialog(hDlg, LOWORD(wParam));
			break;

		case WM_COMMAND:
			EndDialog(hDlg, LOWORD(wParam));
			/*
			if (LOWORD(wParam) == IDOK) {
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			*/
			break;
	}
    return FALSE;
}




LRESULT CALLBACK WidthDlgMsgHandler(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	int xPos, yPos;

	switch (message)
	{
		case WM_INITDIALOG:
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_FULLSCREENNOMENUBAR | SHIDIF_SIPDOWN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			SetFullScreen (hDlg);
			return TRUE; 

		case WM_LBUTTONDOWN:
			xPos = LOWORD(lParam);
			yPos = HIWORD(lParam);

			if (xPos > 10 && xPos < 45) {
				g_strokewidth = 1;
			}
			else if (xPos > 45 && xPos < 80) {
				g_strokewidth = 2;
			}
			else if (xPos > 80 && xPos < 115) {
				g_strokewidth = 3;
			}
			else if (xPos > 115 && xPos < 150) {
				g_strokewidth = 4;
			}
			else if (xPos > 150 && xPos < 185) {
				g_strokewidth = 5;
			}
			else if (xPos > 185 && xPos < 220) {
				g_strokewidth = 6;
			}

			g_hpen = CreatePen (PS_SOLID, g_strokewidth, g_strokecolor);
			SelectObject (g_onscreenDC, g_hpen);
			SelectObject (g_offscreenDC, g_hpen);

			EndDialog(hDlg, LOWORD(wParam));
			break;

		case WM_COMMAND:
			EndDialog(hDlg, LOWORD(wParam));
			/*
			if (LOWORD(wParam) == IDOK) {
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			*/
			break;
	}
    return FALSE;
}


// Mesage handler for the exit dialog.
LRESULT CALLBACK ExitDlgMsgHandler(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
		case WM_INITDIALOG:
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_FULLSCREENNOMENUBAR | SHIDIF_SIPDOWN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			SetFullScreen (hDlg);
			return TRUE; 

		case WM_LBUTTONDOWN:
			EndDialog (hDlg, LOWORD (wParam));
			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				EndDialog(hDlg, LOWORD(wParam));
				CommandBar_Destroy (g_hwndTB);
				// restore button presses to their normal behavior
				GXCloseInput ();
				PostQuitMessage(0);
				return TRUE;
			}
			else {
				EndDialog (hDlg, LOWORD (wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}



void SaveImage ()
{
  DWORD imgCounter = GetCounterValue();

  PBITMAPINFO pInfo = CreateBitmapInfoStruct(g_hwndDrawingArea, g_hBitmap);

  TCHAR szFilename[255];
  wsprintf(szFilename, _T("\\temp\\kc-%d.bmp"), imgCounter);

  CreateBMPFile(g_hwndDrawingArea, szFilename, pInfo, g_offscreenDC);
}


DWORD GetCounterValue ()
{
	DWORD wRetVal;
	HKEY hkKey;
	DWORD wResult;
	DWORD dwImgCounter = 0;

	wRetVal = RegCreateKeyEx (HKEY_CURRENT_USER,
					 		  _T("Software\\priebesoft\\kc"),
							  0,
							  _T("DWORD Value"),
							  0,
							  0,
							  NULL,
							  &hkKey,
							  &wResult);
	if (NULL != hkKey) {
		DWORD dwBuffer;
		DWORD dwBufferSize;
		unsigned long wValueType;

		dwBufferSize = sizeof (DWORD);
		wRetVal = RegQueryValueEx(hkKey, 
								  _T("ImageCounter"),
								  0,
								  &wValueType,
								  (BYTE*)&dwBuffer,
								  &dwBufferSize);
		if (!wRetVal) {
			dwImgCounter = dwBuffer;
		}

		dwImgCounter++;
		dwBufferSize = sizeof (DWORD);
		wRetVal = RegSetValueEx (hkKey,
				  			     _T("ImageCounter"),
							     0,
							     REG_DWORD,
							     (BYTE*)&dwImgCounter,
							     dwBufferSize);
		RegCloseKey (hkKey);
	}

	return dwImgCounter;
}
